Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
Josh Coalson | 6b05bc5 | 2001-06-08 00:13:21 +0000 | [diff] [blame] | 3 | # FLAC - Free Lossless Audio Codec |
Josh Coalson | a78fac6 | 2005-01-25 04:17:55 +0000 | [diff] [blame] | 4 | # Copyright (C) 2001,2002,2003,2004,2005 Josh Coalson |
Josh Coalson | 6b05bc5 | 2001-06-08 00:13:21 +0000 | [diff] [blame] | 5 | # |
Josh Coalson | e8a7601 | 2003-02-07 00:14:32 +0000 | [diff] [blame] | 6 | # This file is part the FLAC project. FLAC is comprised of several |
| 7 | # components distributed under difference licenses. The codec libraries |
| 8 | # are distributed under Xiph.Org's BSD-like license (see the file |
| 9 | # COPYING.Xiph in this distribution). All other programs, libraries, and |
| 10 | # plugins are distributed under the GPL (see COPYING.GPL). The documentation |
| 11 | # is distributed under the Gnu FDL (see COPYING.FDL). Each file in the |
| 12 | # FLAC distribution contains at the top the terms under which it may be |
| 13 | # distributed. |
Josh Coalson | 6b05bc5 | 2001-06-08 00:13:21 +0000 | [diff] [blame] | 14 | # |
Josh Coalson | e8a7601 | 2003-02-07 00:14:32 +0000 | [diff] [blame] | 15 | # Since this particular file is relevant to all components of FLAC, |
| 16 | # it may be distributed under the Xiph.Org license, which is the least |
| 17 | # restrictive of those mentioned above. See the file COPYING.Xiph in this |
| 18 | # distribution. |
Josh Coalson | 6b05bc5 | 2001-06-08 00:13:21 +0000 | [diff] [blame] | 19 | |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 20 | die () |
| 21 | { |
| 22 | echo $* 1>&2 |
| 23 | exit 1 |
| 24 | } |
| 25 | |
Josh Coalson | b43d3cb | 2004-11-09 01:28:05 +0000 | [diff] [blame] | 26 | if [ x = x"$1" ] ; then |
| 27 | BUILD=debug |
| 28 | else |
| 29 | BUILD="$1" |
| 30 | fi |
| 31 | |
| 32 | LD_LIBRARY_PATH=../src/libFLAC/.libs:$LD_LIBRARY_PATH |
| 33 | LD_LIBRARY_PATH=../src/libOggFLAC/.libs:$LD_LIBRARY_PATH |
| 34 | LD_LIBRARY_PATH=../src/share/grabbag/.libs:$LD_LIBRARY_PATH |
| 35 | LD_LIBRARY_PATH=../src/share/getopt/.libs:$LD_LIBRARY_PATH |
| 36 | LD_LIBRARY_PATH=../src/share/replaygain_analysis/.libs:$LD_LIBRARY_PATH |
| 37 | LD_LIBRARY_PATH=../src/share/replaygain_synthesis/.libs:$LD_LIBRARY_PATH |
| 38 | LD_LIBRARY_PATH=../src/share/utf8/.libs:$LD_LIBRARY_PATH |
| 39 | LD_LIBRARY_PATH=../obj/$BUILD/lib:$LD_LIBRARY_PATH |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 40 | export LD_LIBRARY_PATH |
Josh Coalson | b43d3cb | 2004-11-09 01:28:05 +0000 | [diff] [blame] | 41 | PATH=../src/flac:$PATH |
| 42 | PATH=../obj/$BUILD/bin:$PATH |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 43 | BINS_PATH=../../test_files/bins |
| 44 | |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 45 | flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable" |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 46 | |
Josh Coalson | 34c1ea8 | 2002-12-04 04:57:33 +0000 | [diff] [blame] | 47 | run_flac () |
| 48 | { |
Josh Coalson | ecf57b7 | 2003-01-14 09:00:25 +0000 | [diff] [blame] | 49 | if [ x"$FLAC__VALGRIND" = xyes ] ; then |
Josh Coalson | 80936c5 | 2002-12-30 23:31:47 +0000 | [diff] [blame] | 50 | valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --logfile-fd=4 flac $* 4>>test_bins.valgrind.log |
Josh Coalson | 34c1ea8 | 2002-12-04 04:57:33 +0000 | [diff] [blame] | 51 | else |
| 52 | flac $* |
| 53 | fi |
| 54 | } |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 55 | |
Josh Coalson | 21f692b | 2001-07-22 07:25:50 +0000 | [diff] [blame] | 56 | test -d ${BINS_PATH} || exit 77 |
| 57 | |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 58 | test_file () |
| 59 | { |
| 60 | name=$1 |
| 61 | channels=$2 |
| 62 | bps=$3 |
| 63 | encode_options="$4" |
| 64 | |
Josh Coalson | 5367759 | 2004-10-01 16:44:10 +0000 | [diff] [blame] | 65 | echo -n "$name.bin (--channels=$channels --bps=$bps $encode_options): encode..." |
Josh Coalson | ba56c9e | 2004-07-17 00:22:39 +0000 | [diff] [blame] | 66 | cmd="run_flac --verify --silent --force --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin" |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 67 | echo "### ENCODE $name #######################################################" >> ./streams.log |
| 68 | echo "### cmd=$cmd" >> ./streams.log |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 69 | $cmd 2>>./streams.log || die "ERROR during encode of $name" |
| 70 | |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 71 | echo -n "decode..." |
Josh Coalson | ba56c9e | 2004-07-17 00:22:39 +0000 | [diff] [blame] | 72 | cmd="run_flac --silent --force --endian=big --sign=signed --decode --force-raw-format $name.flac"; |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 73 | echo "### DECODE $name #######################################################" >> ./streams.log |
| 74 | echo "### cmd=$cmd" >> ./streams.log |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 75 | $cmd 2>>./streams.log || die "ERROR during decode of $name" |
| 76 | |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 77 | ls -1l $name.bin >> ./streams.log |
| 78 | ls -1l $name.flac >> ./streams.log |
| 79 | ls -1l $name.raw >> ./streams.log |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 80 | |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 81 | echo -n "compare..." |
Josh Coalson | 6218b34 | 2002-12-12 03:58:18 +0000 | [diff] [blame] | 82 | cmp $name.bin $name.raw || die "ERROR during compare of $name" |
| 83 | |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 84 | echo OK |
| 85 | } |
| 86 | |
| 87 | echo "Testing bins..." |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 88 | for f in b00 b01 b02 b03 b04 ; do |
Josh Coalson | 5367759 | 2004-10-01 16:44:10 +0000 | [diff] [blame] | 89 | binfile=$BINS_PATH/$f |
| 90 | if [ -f $binfile.bin ] ; then |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 91 | for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do |
| 92 | for channels in 1 2 4 8 ; do |
| 93 | for bps in 8 16 24 ; do |
| 94 | for opt in 0 1 2 4 5 6 8 ; do |
| 95 | for extras in '' '-p' '-e' ; do |
| 96 | for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do |
| 97 | test_file $binfile $channels $bps "-$opt $extras $blocksize $disable" |
| 98 | done |
| 99 | done |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 100 | done |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 101 | if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then |
| 102 | test_file $binfile $channels $bps "-b 16384 -m -r 8 -l 32 -e -p $disable" |
| 103 | fi |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 104 | done |
| 105 | done |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 106 | done |
Josh Coalson | 94b22e0 | 2002-10-11 06:22:30 +0000 | [diff] [blame] | 107 | else |
| 108 | echo "$binfile not found, skipping." |
| 109 | fi |
Josh Coalson | 60d9d01 | 2001-05-27 18:32:15 +0000 | [diff] [blame] | 110 | done |